package edu.uci.ics.pattis.ics23.collections;


import java.util.Iterator;



public abstract class AbstractPriorityQueue<E> extends AbstractOrderedCollection<E> {

  //Generally, inherit this method without overriding
	public boolean equals(Object o) {
		//Checks external to values in collection
		if (o == this)
			return true;
		if (!(o instanceof PriorityQueue<?>))
			return false;
		PriorityQueue<?> pq = (PriorityQueue<?>) o;
		if (pq.size() != size())
			return false;

		//Checks internal to values in collection: both the same size
		try {
		  Iterator<?> ie2 = pq.iterator();
			for (E e1 : this) {
				Object e2 = ie2.next();
				if (!(e1==null ? e2==null : e1.equals(e2)))
					return false;
			}
		} catch (ClassCastException e) {
			return false;
		} catch (NullPointerException e) {
			return false;
		}

		return true;
	}

	
  
  //Override this method if there is a more efficient algorithm
  //  for a concrete data structure
	public void merge(PriorityQueue<E> other) {
	  if (this == other)
	    return;
	  addAll(other);
	  other.clear();
	}
}
