package edu.uci.ics.pattis.ics23.collections;


import java.util.Iterator;



public abstract class AbstractQueue<E> extends AbstractOrderedCollection<E> {

  //Generally, inherit this method without overriding
	public boolean equals(Object o) {
		//Checks external to values in collection
		if (o == this)
			return true;
		if (!(o instanceof Queue<?>))
			return false;
		Queue<?> q = (Queue<?>) o;
		if (q.size() != size())
			return false;

		//Checks internal to values in collection: both the same size
		try {
		  Iterator<?> ie2 = q.iterator();
			for (E e1 : this) {
				Object e2 = ie2.next();
				if (!(e1==null ? e2==null : e1.equals(e2)))
					return false;
			}
		} catch (ClassCastException e) {
			return false;
		} catch (NullPointerException e) {
			return false;
		}

		return true;
	}
}