package edu.uci.ics.pattis.ics23.collections;



public abstract class AbstractSet<E> extends AbstractCollection<E>{

  //Generally, inherit this method without overriding
	public boolean equals(Object o) {
		//Checks external to values in collection
		if (o == this)
			return true;
		if (!(o instanceof Set<?>))
			return false;
		Set<?> s = (Set<?>) o;
		if (s.size() != size())
			return false;

		//Checks internal to values in collection: both the same size
		try {
			for (Object e : s)
				if (!contains(e))
					return false;
		} catch (ClassCastException e) {
			return false;
		} catch (NullPointerException e) {
			return false;
		}
		return true;
	}
}