package edu.uci.ics.pattis.ics23.collections;
 

import java.util.Iterator;



public interface Collection<E> extends Iterable<E> {
	
  //Commands
  public boolean add       (E e);
  public boolean addAll    (Iterable<? extends E> es);
  public boolean remove    (E e);
  public boolean removeAll (Iterable<? extends E> es);
  public boolean retainAll (Collection<? extends E> c);
  public void    clear     ();
  
  //Queries
  public boolean contains    (Object o);
  public boolean containsAll (Iterable<? extends E> es);
  public boolean isEmpty     ();
  public int     size        ();
  
  //Miscellaneous
  public Iterator<E>   iterator    ();
  public E[]           toArray     ();
  public Collection<E> newEmpty    ();
  public Collection<E> shallowCopy ();

  
  //Inherited (should override)
  public String       toString ();
  public boolean      equals   (Object o);
  public int          hashCode ();
}
