package edu.uci.ics.pattis.ics23.collections;


import edu.uci.ics.pattis.introlib.Prompt;
import edu.uci.ics.pattis.introlib.TypedBufferReader;

import java.util.Iterator;
import java.io.IOException;



public class DriverForList {

  private static Class<?>     classToTest;; 
  private static List<String> l;


  //Present main menu and get user's choice
  //Iterator menu much smaller, so it is not a method 
  private static char menuPrompt (String preface) {
    System.out.println("\n\n"+preface+"Mutators        Accessors            General");
    System.out.println(preface+"  a - add         c - contains          l - load from file");
    System.out.println(preface+"  A - addAll      C - containsAll       i - iterator test");
    System.out.println(preface+"  r - remove      e - isEmpty           q - quit");  
    System.out.println(preface+"  R - removeAll   s - size");  
    System.out.println(preface+"  K - retainAll   [ - toArray ");
    System.out.println(preface+"  x - clear       n - newEmpty");
    System.out.println(preface+"Indexed           S - shallowCopy");
    System.out.println(preface+"  + - add         t - toString");
    System.out.println(preface+"  - - remove      = - equals");
    System.out.println(preface+"  v - set         h - hashCode");
    System.out.println(preface+"  * - addAll    Indexed");
    System.out.println(preface+"  $ - subList     g - get");
    System.out.println(preface+"                  < - indexOf");
    System.out.println(preface+"                  > - lastIndexOf");

    return Prompt.forChar("\n"+preface+"Enter Command","aArRKx+-v*$cCes[nSt=hg<>liq");
  }



  ////////////////
  //Driver Program
  ////////////////

  private static void processIteratorCommands(Iterator<?> i, String preface) {
    for (;;)
      try {
        char iCommand = Prompt.forChar("  Enter h[asNext], n[ext], r[emove], [a]ll next, [e]scape, q[uit]","hnraeq");
        if (iCommand == 'h')
          System.out.println("    hasNext = " + i.hasNext());
        else if (iCommand == 'n')
          System.out.println("    next = " + i.next());
        else if (iCommand == 'r')
          i.remove();
        else if (iCommand == 'e')
          processCommands(preface+"  ");
        else if (iCommand == 'a') {
          while (i.hasNext())
            System.out.println("    (all)next = " + i.next());
          System.out.println("    hasNext is now false");
        }
        else if (iCommand == 'q')
          break;
      } catch (Exception e) {e.printStackTrace();}
  }


  private static void processCommands(String preface) {
    for (;;) try {

      char selection = menuPrompt(preface);

      if (selection == 'a') {
        String e = Prompt.forString(preface+"  Enter element to add");
        System.out.println(preface+"  add = " + l.add(e));
      }

      else if (selection == 'A') {
        Collection<String> c2 = getCollection(classToTest);
        for (;;) {
          String e = Prompt.forString(preface+"  Enter element for c2 (QUIT to quit)");
          if (e.equals("QUIT"))
            break;
          c2.add(e);
        }
        l.addAll(c2);
      }

      else if (selection == '$') {
        int start = Prompt.forInt(preface+"  Enter index to start from");
        int stop  = Prompt.forInt(preface+"  Enter index to stop at   ");
        System.out.println(preface+"  subList = " + l.subList(start,stop));
      }

      else if (selection == 'r') {
        String e = Prompt.forString(preface+"  Enter element to remove");
        System.out.println(preface+"  remove = " + l.remove(e));
      }

      else if (selection == 'R') {
        Collection<String> c2 = getCollection(classToTest);
        for (;;) {
          String e = Prompt.forString(preface+"  Enter element for c2 (QUIT to quit)");
          if (e.equals("QUIT"))
            break;
          c2.add(e);
        }
        l.removeAll(c2);
      }

      else if (selection == 'K') {
        Collection<String> c2 = getCollection(classToTest);
        for (;;) {
          String e = Prompt.forString(preface+"  Enter element for c2 (QUIT to quit)");
          if (e.equals("QUIT"))
            break;
          c2.add(e);
        }
        l.retainAll(c2);
      }

      else if (selection == 'x')
        l.clear();

      else if (selection == 'c') {
        String e = Prompt.forString(preface+"  Enter element to check");
        System.out.println(preface+"  contains = " + l.contains(e));
      }

      else if (selection == '+') {
        int    i = Prompt.forInt(preface+"  Enter index to add at");
        String e = Prompt.forString(preface+"  Enter element to add");
        l.add(i,e);
      }

      else if (selection == '-') {
        int    i = Prompt.forInt(preface+"  Enter index to remove from");
        System.out.println(preface+"  remove = " + l.remove(i));
      }

      else if (selection == 'v') {
        int    i = Prompt.forInt(preface+"  Enter index to set at");
        String e = Prompt.forString(preface+"  Enter element to set to");
        System.out.println(preface+"  set = " + l.set(i,e));
      }

      else if (selection == '*') {
        int                 i = Prompt.forInt(preface+"  Enter index to add at");
        Collection<String> c2 = getCollection(classToTest);
        for (;;) {
          String e = Prompt.forString(preface+"  Enter element for c2 (QUIT to quit)");
          if (e.equals("QUIT"))
            break;
          c2.add(e);
        }
        l.addAll(i,c2);
      }

      else if (selection == 'C') {
        Collection<String> c2 = getCollection(classToTest);
        for (;;) {
          String e = Prompt.forString(preface+"  Enter element for c2 (QUIT to quit)");
          if (e.equals("QUIT"))
            break;
          c2.add(e);
        }
        System.out.println(preface+"  containsAll = " + l.containsAll(c2));
      }

      else if (selection == 'e')
        System.out.println(preface+"  isEmpty = " + l.isEmpty());

      else if (selection == 's')
        System.out.println(preface+"  size = " + l.size());

      else if (selection == '[') {
        Object[] a = l.toArray();
        System.out.println(preface+"  toArray() = ");
        for (int i=0; i<a.length; i++)
          System.out.println(preface+"    " + a[i]);
      }   

      else if (selection == 'n') {
        System.out.println("  newEmpty = " + l.newEmpty());
      }   

      else if (selection == 'S') {
        Collection<String> c2 = l.shallowCopy();
        System.out.println(preface+"  c equals shallowCopy? = " + l.equals(c2));
        System.out.println(preface+"  shallowCopy equals c? = " + c2.equals(l));
        System.out.println(preface+"  c == shallowCopy?     = " + (l==c2));
      }   

      else if (selection == 't')
        System.out.println(preface+"  toString = " + l);

      else if (selection == '=') {
        Collection<String> c2 = getCollection(classToTest);
        for (;;) {
          String e = Prompt.forString(preface+"  Enter key for m2 (QUIT to quit)");
          if (e.equals("QUIT"))
            break;
          c2.add(e);
        }
        System.out.println(preface+"  c.equals(m2) = " + l.equals(c2));
        System.out.println(preface+"  m2.equals(m) = " + c2.equals(l));
      }

      else if (selection == 'h')
        System.out.println(preface+"  hashCode = " + l.hashCode());

      else if (selection == 'g') {
        int    i = Prompt.forInt(preface+"  Enter index to get from");
        System.out.println(preface+"  get = " + l.get(i));
      }

      else if (selection == '<') {
        String e = Prompt.forString(preface+"  Enter element to get index of");
        System.out.println(preface+"  indexOf = " + l.indexOf(e));
      }

      else if (selection == '>') {
        String e = Prompt.forString(preface+"  Enter element to get last index of");
        System.out.println(preface+"  lastIndexOf = " + l.lastIndexOf(e));
      }

      else if (selection == 'l') {
        TypedBufferReader input = new TypedBufferReader ("  Enter file (containing strings) name");
        try {
          for (;;)
            l.add(input.readString());
        }catch (IOException ioe){}
      }

      else if (selection == 'i')
        processIteratorCommands(l.iterator(), preface+"  ");

      else if (selection == 'q')
        break;

      else
        System.out.println(preface+"\""+selection+"\" is unknown command");
    } catch (Exception e) {
      e.printStackTrace();
    }

  }



  @SuppressWarnings("unchecked")
  private static List<String> getCollection(Class<?> cl) throws Exception
  {return (List<String>)(cl.getConstructor((Class<?>[])null)).newInstance((Object[])null);}




  public static void main(String[] args) throws Exception {
    //Construct object to test
    String kind        = "List";
    String packageName = Prompt.forString("Enter package name for classes","edu.uci.ics.pattis.ics23.collections");

    String[] availableClasses =  DriverMagic.getClasses(packageName,kind);
    classToTest = DriverMagic.getClass(packageName,kind,availableClasses); 
    l = getCollection(classToTest);

    //Test object using any method
    processCommands("");
  }


}
