package edu.uci.ics.pattis.ics23.collections;


import edu.uci.ics.pattis.introlib.Prompt;
import edu.uci.ics.pattis.introlib.TypedBufferReader;

import java.io.IOException;
import java.util.Comparator;
import java.util.Iterator;





public class DriverForOrderedCollection {

  private static Class<?>                  classToTest;
  private static OrderedCollection<String> o;


  //Present main menu and get user's choice
  //Iterator menu much smaller, so it is not a method 
  private static char menuPrompt (String preface) {
    System.out.println("\n\n"+preface+"Mutators       Accessors         General");
    System.out.println(preface+"  a - add        p - peek           l - load from file");
    System.out.println(preface+"  A - addAll     e - isEmpty        f - flush: remove until isEmpty");
    System.out.println(preface+"  r - remove     s - size           i - iterator test");
    System.out.println(preface+"  x - clear      [ - toArray        q - quit");
    System.out.println(preface+"                 n - newEmpty");
    System.out.println(preface+"                 S - shallowCopy");
    System.out.println(preface+"                 t - toString");
    System.out.println(preface+"                 = - equals");
    System.out.println(preface+"                 h - hashCode ");
    if (o instanceof PriorityQueue<?>) {
      System.out.println();
      System.out.println(preface+"(merge method for PriorityQueue is NOT driveable here)");
    }

    return Prompt.forChar("\n"+preface+"Enter Command","aArxpes[nSt=hlfiq");
  }



  ////////////////
  //Driver Program
  ////////////////

  private static void processIteratorCommands(Iterator<?> i, String preface) {
    for (;;)
      try {
        char iCommand = Prompt.forChar("  Enter h[asNext], n[ext], r[emove], [a]ll next, [e]scape, q[uit]","hnraeq");
        if (iCommand == 'h')
          System.out.println("    hasNext = " + i.hasNext());
        else if (iCommand == 'n')
          System.out.println("    next = " + i.next());
        else if (iCommand == 'r')
          i.remove();
        else if (iCommand == 'e')
          processCommands(preface+"  ");
        else if (iCommand == 'a') {
          while (i.hasNext())
            System.out.println("    (all)next = " + i.next());
          System.out.println("    hasNext is now false");
        }
        else if (iCommand == 'q')
          break;
      } catch (Exception e) {e.printStackTrace();}
  }


  private static void processCommands(String preface) {
    for (;;) try {

      char selection = menuPrompt(preface);

      if (selection == 'a')
        System.out.print(preface+"  add = " + o.add(Prompt.forString("  Enter String to add")));

      else if (selection == 'A') {
        OrderedCollection<String> o2 = getCollection(classToTest,
            new Comparator<String>() {
          public int compare (String a, String b) {
            return -a.compareTo(b);
          } 
        }
        ); 

        for (;;) {
          String e = Prompt.forString(preface+"  Enter element for o2 (QUIT to quit)");
          if (e.equals("QUIT"))
            break;
          o2.add(e);
        }
        o.addAll(o2);
      }

      else if (selection == 'r')
        System.out.println(preface+"  remove = " + o.remove());

      else if (selection == 'x')
        o.clear();


      else if (selection == 'p')
        System.out.println(preface+"  peek = " + o.peek());

      else if (selection == 'e')
        System.out.println(preface+"  isEmpty = " + o.isEmpty());

      else if (selection == 's')
        System.out.println(preface+"  size = " + o.size());

      else if (selection == '[') {
        Object [] a = o.toArray();
        System.out.println(preface+"  toArray() = ");
        for (int i=0; i<a.length; i++)
          System.out.println(preface+"    " + a[i]);
      }   

      else if (selection == 'n') {
        System.out.println("  newEmpty = " + o.newEmpty());
      }   

      else if (selection == 'S') {
        OrderedCollection<String> o2 = o.shallowCopy();
        System.out.println(preface+"  o equals shallowCopy? = " + o.equals(o2));
        System.out.println(preface+"  shallowCopy equals o? = " + o2.equals(o));
        System.out.println(preface+"  o == shallowCopy?     = " + (o==o2));
      }   

      else if (selection == 't')
        System.out.println(preface+"  toString = " + o.toString());

      else if (selection == '=') {
        OrderedCollection<String> o2 = getCollection(classToTest,
            new Comparator<String>() {
          public int compare (String a, String b) {
            return -a.compareTo(b);
          } 
        }
        ); 

        for (;;) {
          String e = Prompt.forString(preface+"  Enter element for o2 (QUIT to quit)");
          if (e.equals("QUIT"))
            break;
          o2.add(e);
        }
        System.out.println(preface+"  o.equals(m2) = " + o.equals(o2));
        System.out.println(preface+"  o2.equals(m) = " + o2.equals(o));
      }

      else if (selection == 'h')
        System.out.println(preface+"  hashCode = " + o.hashCode());

      else if (selection == 'l') {
        TypedBufferReader input = new TypedBufferReader ("  Enter file (containing strings) name");
        try {
          for (;;)
            o.add(input.readString());
        }catch (IOException ioe){}
      }

      else if (selection == 'f')
        for(;!o.isEmpty();)
          System.out.println(preface+"  next = " + o.remove());

      else if (selection == 'i')
        processIteratorCommands(o.iterator(), preface+"  ");

      else if (selection == 'q')
        break;

      else
        System.out.println(preface+"\""+selection+"\" is unknown command");

    } catch (Exception e) {
      e.printStackTrace();
    }
  }



  @SuppressWarnings("unchecked")
  public static OrderedCollection<String> getCollection(Class<?> cl, Comparator<?> comparator) throws Exception {
    if (cl.getName().indexOf("PriorityQueue") != -1)
      return (OrderedCollection<String>)(cl.getConstructor(new Class[]{Class.forName("java.util.Comparator")})).
      newInstance(new Object[]{comparator});
    else
      return (OrderedCollection<String>)(cl.getConstructor((Class<?>[])null)).newInstance((Object[])null);
  }


  public static void main(String[] args) throws Exception {
    //Construct object to test
    String kind        = "OrderedCollection";
    String packageName = Prompt.forString("Enter package name for classes","edu.uci.ics.pattis.ics23.collections");

    String[] availableClasses =  DriverMagic.getClasses(packageName,kind);
    classToTest = DriverMagic.getClass(packageName,kind,availableClasses); 
    o = getCollection(classToTest,
        new Comparator<String>() {
      public int compare (String a, String b) {
        return -a.compareTo(b);
      } 
    }
    ); 

    //Test object using any method
    processCommands("");
  }


}
