package edu.uci.ics.pattis.ics23.collections;



public interface Map<K,V>  {
	
  //Commands
  public V    put    (K key, V value);
  public void putAll (Iterable<Entry<K,V>> keysValues);
  public V    remove (K key);
  public void clear  ();
  
  //Queries
  public V                    get          (Object key);
  public boolean              containsKey  (Object key);
  public boolean              containsValue(Object value);
  public Iterable<Entry<K,V>> entries      ();
  public Iterable<K>          keys         ();
  public Iterable<V>          values       ();
  public boolean              isEmpty      ();
  public int                  size         ();
  
  //Miscellaneous
  public Entry<K,V>[] toArray     ();
  public Map<K,V>     newEmpty    ();
  public Map<K,V>     shallowCopy ();
  
  //Inherited (should override)
  public String       toString ();
  public boolean      equals   (Object o);
  public int          hashCode ();
  
  public interface Entry<K,V> {
    public K getKey   ();
    public V getValue ();
    public V setValue (V newValue);
  }

}
