package edu.uci.ics.pattis.ics23.collections;
 

import java.util.Iterator;
import java.util.NoSuchElementException;



public interface OrderedCollection<E> extends Iterable<E> {
	
  //Commands
  public boolean add    (E e);
  public boolean addAll (Iterable<? extends E> es);
  public E       remove ()  throws NoSuchElementException;
  public void    clear  ();
  
  //Queries
  public E        peek    () throws NoSuchElementException;
  public boolean  isEmpty ();
  public int      size    ();
  
  //Miscellaneous
  public Iterator<E>          iterator    ();
  public E[]                  toArray     ();
  public OrderedCollection<E> newEmpty    ();
  public OrderedCollection<E> shallowCopy ();

  
  //Inherited (should override)
  public String   toString ();
  public boolean  equals   (Object o);
  public int      hashCode ();
}
